package com.demo.utils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.*;

public class UserDataProvider {


    private static final List<Map<String, String>> allUsers = new ArrayList<>();
    private static final Random random = new Random();

    static {
        loadUsersFromCsv("src/test/resources/users.csv");
    }

    private static void loadUsersFromCsv(String filePath) {
        try (BufferedReader reader = new BufferedReader(new FileReader(filePath))) {
            String[] headers = reader.readLine().split(",");
            String line;
            while ((line = reader.readLine()) != null) {
                String[] values = line.split(",");
                Map<String, String> user = new HashMap<>();
                for (int i = 0; i < headers.length; i++) {
                    user.put(headers[i].trim(), values[i].trim());
                }
                allUsers.add(user);
            }
        } catch (Exception e) {
            throw new RuntimeException("Failed to load users", e);
        }
    }

    // Return a random user from the full list
    public static Map<String, String> getRandomUser() {
        return allUsers.get(random.nextInt(allUsers.size()));
    }


}
